﻿Imports System.Runtime.CompilerServices

Namespace Helpers.BitOperation

   Public Module BitOperationX


      <Extension(), DebuggerStepThrough()> _
      Public Sub SetFlag(Of T)(ByRef Subj As T, ByVal Value As T, Optional ByVal [on] As Boolean = True)
         If [on] Then
            Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or DirectCast(DirectCast(Value, Object), Integer), Object), T)
         Else
            Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) And Not DirectCast(DirectCast(Value, Object), Integer), Object), T)
         End If
      End Sub

      '<Extension()> _
      'Public Sub SetFlag(Of T)(ByRef Subj As T, ByVal Value As Integer, Optional ByVal [on] As Boolean = True)
      '   If [on] Then
      '      Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or Value, Object), T)
      '   Else
      '      Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Or Not Value, Object), T)
      '   End If
      'End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Sub [And](Of T)(ByRef Subj As T, ByVal Value As T)
         Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) And DirectCast(DirectCast(Value, Object), Integer), Object), T)
      End Sub
      <Extension(), DebuggerStepThrough()> _
      Public Sub [Xor](Of T)(ByRef Subj As T, ByVal Value As T)
         Subj = DirectCast(DirectCast(DirectCast(DirectCast(Subj, Object), Integer) Xor DirectCast(DirectCast(Value, Object), Integer), Object), T)
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Function HasFlag(ByVal Subj As Integer, ByVal Value As Integer) As Boolean
         Return (Subj And Value) = Value
      End Function

   End Module

End Namespace
