﻿Imports System.Runtime.CompilerServices

Namespace System
   'Public Class [Enum]
   '   Public Shared Sub SetFlag(
   'End Class


   Public Module MiscX

      <Extension(), DebuggerStepThrough()> _
      Public Function OrDefaultValue(Of T As Structure)(ByVal Subj As T?, ByVal defaultValue As T) As T
         Return If(Subj.HasValue, Subj.Value, defaultValue)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Sub [Xor](ByRef Subj As Boolean, ByVal Value As Boolean)
         Subj = Subj Xor Value
      End Sub
      <Extension(), DebuggerStepThrough()> _
      Public Sub [Or](ByRef Subj As Boolean, ByVal Value As Boolean)
         Subj = Subj Or Value
      End Sub
      <Extension(), DebuggerStepThrough()> _
      Public Function Abs(ByVal Subj As Integer) As Integer
         Return If(Subj < 0, -Subj, Subj)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function TryParseX(ByRef Subj As Integer, ByVal s As String) As Boolean
         Return Integer.TryParse(s, Subj)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function TryParseX(ByRef Subj As Decimal, ByVal s As String) As Boolean
         Return Decimal.TryParse(s, Subj)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function TryParseX(ByRef Subj As Double, ByVal s As String) As Boolean
         Return Double.TryParse(s, Subj)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function TryParseX(ByRef Subj As Single, ByVal s As String) As Boolean
         Return Single.TryParse(s, Subj)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function TryParseX(ByRef Subj As Date, ByVal s As String) As Boolean
         Return Date.TryParse(s, Subj)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Sub Times(ByVal n As Integer, ByVal action As Action)
         For i = 0 To n - 1 : action() : Next
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Sub Times(ByVal n As Integer, ByVal action As Action(Of Integer))
         For i = 0 To n - 1 : action(i) : Next
      End Sub
      <Extension(), DebuggerStepThrough()> _
      Public Function Times(Of T)(ByVal n As Integer, ByVal func As Func(Of T)) As IEnumerable(Of T)
         Return From i In enumerable.Range(0, n) Select func.Invoke
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function Times(Of T)(ByVal n As Integer, ByVal func As Func(Of Integer, T)) As IEnumerable(Of T)
         Return From i In enumerable.Range(0, n) Select func.Invoke(i)
      End Function
      <Extension(), DebuggerStepThrough()> _
      Public Function Times(ByVal count As Integer) As Sequence
         Return New Sequence With {._Count = count}
      End Function

      Public Class Sequence : Implements IEnumerable(Of Integer)
         Private _Start As Integer = 0
         Private _Step As Integer = 1
         Public _Count As Integer
         <DebuggerStepThrough()> _
         Public Function [Step](value As Integer) As Sequence
            _Step = value
            Return Me
         End Function
         <DebuggerStepThrough()> _
         Public Function From(ByVal value As Integer) As Sequence
            _Start = value
            Return Me
         End Function
         Public Function From(Of T)(ByVal start As Integer, ByVal convert As Func(Of Integer, T)) As IEnumerable(Of T)
            Return From i In From(start) Select convert(i)
         End Function
         <DebuggerStepThrough()> _
         Public Sub From(ByVal start As Integer, ByVal action As Action(Of Integer))
            For i = start To (_Count - 1) * _Step + start Step _Step : action(i) : Next
         End Sub
         Public Function GetEnumerator() As IEnumerator(Of Integer) Implements IEnumerable(Of Integer).GetEnumerator
            Return (From i In Enumerable.Range(0, _Count) Select i * _Step + _Start).GetEnumerator
         End Function
         Private Function GetEnumerator1() As IEnumerator Implements IEnumerable.GetEnumerator
            Return GetEnumerator()
         End Function
      End Class

      'Public Class IterationCount : Implements IEnumerable(Of Integer)
      '   Private _Start As Integer = 0
      '   Private _Step As Integer = 1
      '   Public _Count As Integer
      '   Public Function [Step](value As Integer) As IterationCount
      '      _Step = value
      '      Return Me
      '   End Function
      '   Public Function From(ByVal value As Integer) As IterationCount
      '      _Start = value
      '      Return Me
      '   End Function
      '   Public Function From(Of T)(ByVal start As Integer, ByVal convert As Func(Of Integer, T)) As IEnumerable(Of T)
      '      Return From i In Enumerable.Range(start, _Count) Select convert(i)
      '   End Function
      '   <DebuggerStepThrough()> _
      '   Public Sub From(ByVal n As Integer, ByVal action As Action)
      '      For i = 0 To _Count - n : action() : Next
      '   End Sub
      '   <DebuggerStepThrough()> _
      '   Public Sub From(ByVal n As Integer, ByVal action As Action(Of Integer))
      '      For i = 0 To _Count - n : action(i) : Next
      '   End Sub

      '   Public Function GetEnumerator() As Collections.Generic.IEnumerator(Of Integer) Implements Collections.Generic.IEnumerable(Of Integer).GetEnumerator
      '      Return (From i In Enumerable.Range(0, _Count) Select i * _Step + _Start).GetEnumerator
      '   End Function

      '   Private Function GetEnumerator1() As Collections.IEnumerator Implements Collections.IEnumerable.GetEnumerator
      '      Return GetEnumerator()
      '   End Function
      'End Class

      'Public Class IterationCount : Implements ISequence
      '   Private _Step As Integer
      '   Public count As Integer
      '   Public Function [Step](value As Integer) As ISequence
      '      _Step = value
      '      Return Me
      '   End Function
      '   Public Interface ISequence
      '      Function From(ByVal start As Integer) As IEnumerable(Of Integer)
      '   End Interface
      '   Public Function From(ByVal start As Integer) As IEnumerable(Of Integer)
      '      Return Enumerable.Range(start, count)
      '   End Function
      '   Public Function From(Of T)(ByVal start As Integer, ByVal convert As Func(Of Integer, T)) As IEnumerable(Of T)
      '      Return From i In Enumerable.Range(start, count) Select convert(i)
      '   End Function
      '   <DebuggerStepThrough()> _
      '   Public Sub From(ByVal n As Integer, ByVal action As Action)
      '      For i = 0 To count - n : action() : Next
      '   End Sub
      '   <DebuggerStepThrough()> _
      '   Public Sub From(ByVal n As Integer, ByVal action As Action(Of Integer))
      '      For i = 0 To count - n : action(i) : Next
      '   End Sub
      '   Private Function FromByStep(start As Integer) As IEnumerable(Of Integer) Implements ISequence.From
      '      Return From i In Enumerable.Range(0, count) Select i * _Step + start
      '   End Function
      'End Class


   End Module

End Namespace
